#include <bits/stdc++.h>
using namespace std;

#define int __int128
//#define int long long
#define f first
#define s second
#define endl '\n'

const int mod=1000000000000000583;
const int p=101;

vector <int> st(1000000,1);

int step(int a, int n)
{
    if (n==0)return 1;
    if (n==1)return a;
    int b=step(a,n/2);
    return b*b%mod*step(a,n%2)%mod;
}

vector <int> get_h(vector <int> a, int k)
{
    int n=a.size();
    vector <int> ha(n+1,0);
    for (int i=1; i<=n; i++){
        ha[i]=ha[i-1]*p+a[i-1];
        ha[i]%=mod;
    }
    vector <int> hka;
    for (int i=0; i+k-1<n; i++){
        int x=0;
        x=ha[i+k]-ha[i]*st[k];
        if (x<0)x+=mod*mod;
        x%=mod;
        hka.push_back(x);
    }
    return hka;
}

bool can_k1(vector <int> a, vector <int> b, int k)
{
    vector <int> hka=get_h(a,k);
    vector <int> hkb=get_h(b,k);
    reverse(a.begin(),a.end());
    reverse(b.begin(),b.end());
    vector <int> hkar=get_h(a,k);
    vector <int> hkbr=get_h(b,k);
    reverse(hkar.begin(),hkar.end());
    reverse(hkbr.begin(),hkbr.end());

    for (int i=0; i<hka.size(); i++){
        hka[i]-=hkar[i];
    }
    for (int i=0; i<hkb.size(); i++){
        hkb[i]=hkbr[i]-hkb[i];
    }
    for (int i=0; i<hka.size(); i++){
        if (hka[i]<0)hka[i]+=mod*mod;
        hka[i]%=mod;
    }
    for (int i=0; i<hkb.size(); i++){
        if (hkb[i]<0)hkb[i]+=mod*mod;
        hkb[i]%=mod;
    }

    sort(hka.begin(),hka.end());
    sort(hkb.begin(),hkb.end());
    int i=0;
    int j=0;
    while (1){
        if (i==hka.size())break;
        if (j==hkb.size())break;
        if (hka[i]==hkb[j])return 1;
        if (hka[i]<hkb[j])i++;
        else j++;
    }
    return 0;
}

int solve1(vector <int> a, vector <int> b)
{
    int n=a.size();
    int m=b.size();
    int l=-1;
    int r=min(n,m);
    r+=r%2;
    r+=1;
    while (l+2<r){
        int m=(l+r)>>1;
        if (m%2==0)m++;

        if (can_k1(a,b,m))l=m;
        else r=m;
    }
    return l;
}

bool can_k(vector <int> a, vector <int> b, int k)
{
    vector <int> hka=get_h(a,k);
    vector <int> hkb=get_h(b,k);
    reverse(a.begin(),a.end());
    reverse(b.begin(),b.end());
    vector <int> hkar=get_h(a,k);
    vector <int> hkbr=get_h(b,k);
    reverse(hkar.begin(),hkar.end());
    reverse(hkbr.begin(),hkbr.end());

    for (int i=0; i<hka.size(); i++){
        hka[i]-=hkar[i];
    }
    for (int i=0; i<hkb.size(); i++){
        hkb[i]=hkbr[i]-hkb[i];
    }
    sort(hka.begin(),hka.end());
    sort(hkb.begin(),hkb.end());
    int i=0;
    int j=0;
    while (1){
        if (i==hka.size())break;
        if (j==hkb.size())break;
        if (hka[i]==hkb[j])return 1;
        if (hka[i]<hkb[j])i++;
        else j++;
    }
    return 0;
}

int solve0(vector <int> a, vector <int> b)
{
    int n=a.size();
    int m=b.size();
    int l=0;
    int r=min(n,m);
    r-=r%2;
    r+=2;
    while (l+2<r){
        int m=(l+r)>>1;
        if (m%2==1)m++;

        if (can_k(a,b,m))l=m;
        else r=m;
    }
    return l;
}


void solve(vector <int> a, vector <int> b)
{
    int ans0=solve0(a,b);
    int ans1=solve1(a,b);
    cout << max((long long)ans1,(long long)ans0) << endl;
    return;
}

int read()
{
    long long x;
    cin >> x;
    return x;
}

bool prost(int n)
{
    for (int i=2; i*i<=n; i++){
        if (n%i==0)return 0;
    }
    return 1;
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL
    /*for (int i=1000000000000000501; i<=1000000000000001001; i+=2){
        if (prost(i))cout << (long long)i << " ";
    }*/
    int n,m;
    n=read();
    m=read();
    for (int i=1; i<1000000; i++){
        st[i]=st[i-1]*p%mod;
    }
    vector <int> a(n);
    vector <int> b(m);
    for (int i=0; i<n; i++){
        a[i]=read();
    }
    for (int i=0; i<m; i++){
        b[i]=read();
    }

    solve(a,b);
    return 0;
}
/**
5 6
4 3 3 2 1
4 1 5 1 3 2


11 6
1 2 3 3 2 1 1 2 3 2 1
6 6 6 6 6 6

5 10
1 2 3 1 1
10 2 3 1 2 100 3 1 1 1

2 3 5 7 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71 73 79 83 89 97
1000000000000000003 1000000000000000009 1000000000000000031 1000000000000000079
1000000000000000507 1000000000000000523
1000000000000000507 1000000000000000583
1000000000000000177
*/
