#include <bits/stdc++.h>
using namespace std;

#define int long long
#define f first
#define s second
#define endl '\n'
#define double long double

struct point
{
    int x,y;
    point(){}
    point(int x, int y):x(x),y(y){}
};

int operator *(point a, point b)
{
    return a.x*b.x+a.y*b.y;
}
int operator %(point a, point b)
{
    return a.x*b.y-a.y*b.x;
}
///__
///ab
///a->b
point operator -(point a, point b)
{
    return {b.x-a.x,b.y-a.y};
}

struct triangle
{
    point a,b,c;
    triangle(){}
};

vector <int> pos;

triangle transpos(triangle a, int k)
{
    if (k==0)return a;
    if (k==1){
        triangle a1;
        a1.a=a.b;
        a1.b=a.c;
        a1.c=a.a;
        return a1;
    }
    if (k==2){
        triangle a1;
        a1.a=a.c;
        a1.b=a.a;
        a1.c=a.b;
        return a1;
    }
    assert(0);
}

const double pi=3.14159265358979311600;
const double eps=0.0000001;

int len2(point x)
{
    return x.x*x.x+x.y*x.y;
}

void write(triangle a)
{
    cout << a.a.x << " " << a.a.y << "  " << a.b.x << " " << a.b.y << "  " << a.c.x << " " << a.c.y << endl;
}

bool good(triangle a, triangle b, triangle c, triangle d, bool need=0)
{
    b=transpos(b,pos[0]);
    c=transpos(c,pos[1]);
    d=transpos(d,pos[2]);
    if (need){
    write(a);
    write(b);
    write(c);
    write(d);
    }

    if (len2(a.a-a.b)!=len2(b.a-b.b))return 0;
    if (len2(a.b-a.c)!=len2(c.a-c.b))return 0;
    if (len2(a.c-a.a)!=len2(d.a-d.b))return 0;

    if (need)cout << "+" << endl;
    {
        double angle=0.0;
        double x=atan2((b.a-b.b)%(b.a-b.c),(b.a-b.b)*(b.a-b.c));
        angle+=x;
        double y=atan2((a.b-a.c)%(a.b-a.a),(a.b-a.c)*(a.b-a.a));
        angle+=y;
        double z=atan2((c.b-c.c)%(c.b-c.a),(c.b-c.c)*(c.b-c.a));
        angle+=z;
        /*cout << setprecision(10) << fixed << x*180.0/pi << endl;
        cout << y*180.0/pi << endl;
        cout << z*180.0/pi << endl;*/
        if (/*abs(angle)>eps && */abs(angle-pi)>eps){
            if (need)cout << "angle 1" << endl;
            //cout << setprecision(10) << fixed << angle << endl;
            return 0;
        }
    }
    {
        double angle=0.0;
        angle+=atan2((c.a-c.b)%(c.a-c.c),(c.a-c.b)*(c.a-c.c));
        angle+=atan2((a.c-a.a)%(a.c-a.b),(a.c-a.a)*(a.c-a.b));
        angle+=atan2((d.b-d.c)%(d.b-d.a),(d.b-d.c)*(d.b-d.a));
        if (/*abs(angle)>eps && */abs(angle-pi)>eps){
            if (need)cout << "angle 2" << endl;
            return 0;
        }
    }
    {
        double angle=0.0;
        angle+=atan2((d.a-d.b)%(d.a-d.c),(d.a-d.b)*(d.a-d.c));
        angle+=atan2((a.a-a.b)%(a.a-a.c),(a.a-a.b)*(a.a-a.c));
        angle+=atan2((b.b-b.c)%(b.b-b.a),(b.b-b.c)*(b.b-b.a));
        if (/*abs(angle)>eps && */abs(angle-pi)>eps){
            if (need)cout << "angle 3" << endl;
            return 0;
        }
    }

    return 1;
}

bool check(triangle a, triangle b, triangle c, triangle d, bool need=0)
{
    for (int m=0; m<27; m++){
        pos={m/9,m/3%3,m%3};
        int need1=0;
        //if (need && m==15)need1=1;
        if (good(a,b,c,d,need1))return 1;
    }
    return 0;
}


triangle read_tri()
{
    triangle x;
    cin >> x.a.x >> x.a.y;
    cin >> x.b.x >> x.b.y;
    cin >> x.c.x >> x.c.y;
    return x;
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL

    int test;
    cin >> test;
    int n;
    cin >> n;
    vector <triangle> a(n);
    for (int i=0; i<n; i++){
        a[i]=read_tri();
    }
    vector <vector <int> > b;
    vector <vector <vector <vector <bool> > > > can(n,vector <vector <vector <bool> > > (n,vector <vector <bool> > (n,vector <bool> (n,0))));
    int ans=0;
    for (int i=0; i<n; i++){
        for (int j=0; j<n; j++){
            for (int k=0; k<n; k++){
                for (int l=0; l<n; l++){
                    if (i==j || i==k || i==l || j==k || j==l || k==l)continue;
                    if (can[i][j][k][l])continue;
                    //bool need=0;
                    //if (i==1 && j==0 && k==2 && l==3)need=1;
                    if (check(a[i],a[j],a[k],a[l])){
                        ans++;
                        b.push_back({i+1,j+1,k+1,l+1});

                        can[i][j][k][l]=1;
                        can[i][j][l][k]=1;
                        can[i][k][j][l]=1;
                        can[i][k][l][j]=1;
                        can[i][l][k][j]=1;
                        can[i][l][j][k]=1;

                        can[j][i][k][l]=1;
                        can[j][i][l][k]=1;
                        can[j][k][i][l]=1;
                        can[j][k][l][i]=1;
                        can[j][l][k][i]=1;
                        can[j][l][i][k]=1;

                        can[k][j][i][l]=1;
                        can[k][j][l][i]=1;
                        can[k][i][j][l]=1;
                        can[k][i][l][j]=1;
                        can[k][l][i][j]=1;
                        can[k][l][j][i]=1;

                        can[l][j][k][i]=1;
                        can[l][j][i][k]=1;
                        can[l][k][j][i]=1;
                        can[l][k][i][j]=1;
                        can[l][i][k][j]=1;
                        can[l][i][j][k]=1;
                    }
                }
            }
        }
    }
    cout << ans << endl;
    for (auto i:b){
        for (auto j:i){
            cout << j << " ";
        }
        cout << endl;
    }
}
/**
1
4
0 0 6 2 1 2
0 0 5 0 6 3
0 0 3 1 1 3
0 0 6 3 3 6

*/
